Package org.apache.velocity.context

# Class AbstractContext

java.lang.Object
org.apache.velocity.context.AbstractContext

All Implemented Interfaces:
  `Context`, `InternalEventContext`

Direct Known Subclasses:
  `VelocityContext`

public abstract class AbstractContext extends Object implements Context
This class is the abstract base class for all conventional Velocity Context implementations. Simply extend this class and implement the abstract routines that access your preferred storage method. Takes care of context chaining. Also handles / enforces policy on null keys and values :

- Null keys and values are accepted and basically dropped.
- If you place an object into the context with a null key, it will be ignored and logged.
- If you try to place a null into the context with any key, it will be dropped and logged.

The default implementation of this for application use is org.apache.velocity.VelocityContext. All thanks to Fedor for the chaining idea.

Version:
  $Id$
Author:
  Geir Magnusson Jr., Fedor Karpelevitch, Jason van Zyl

## Constructor Summary

Constructors
Constructor
Description
`AbstractContext()`
default CTOR
`AbstractContext(Context inner)`
Chaining constructor accepts a Context argument.

## Method Summary

Modifier and Type
Method
Description
`EventCartridge`
`attachEventCartridge(EventCartridge ec)`
`boolean`
`containsKey(String key)`
Indicates whether the specified key is in the context.
`Object`
`get(String key)`
Gets the value corresponding to the provided key from the context.
`Context`
`getChainedContext()`
returns innerContext if one is chained
`int`
`getCurrentMacroCallDepth()`
get the current macro call depth
`String`
`getCurrentMacroName()`
get the current macro name
`Resource`
`getCurrentResource()`
`String`
`getCurrentTemplateName()`
get the current template name
`EventCartridge`
`getEventCartridge()`
`String[]`
`getKeys()`
Get all the keys for the values in the context
`List<Template>`
`getMacroLibraries()`
`String[]`
`getMacroNameStack()`
get the current macro name stack
`String[]`
`getTemplateNameStack()`
get the current template name stack
`IntrospectionCacheData`
`icacheGet(Object key)`
returns an IntrospectionCache Data (@see IntrospectionCacheData) object if exists for the key
`void`
`icachePut(Object key, IntrospectionCacheData o)`
places an IntrospectionCache Data (@see IntrospectionCacheData) element in the cache for specified key
`abstract boolean`
`internalContainsKey(String key)`
Implement to determine if a key is in the storage.
`abstract Object`
`internalGet(String key)`
Implement to return a value from the context storage.
`abstract String[]`
`internalGetKeys()`
Implement to return an object array of key strings from your storage.
`abstract Object`
`internalPut(String key, Object value)`
Implement to put a value into the context storage.
`abstract Object`
`internalRemove(String key)`
Implement to remove an item from your storage.
`void`
`popCurrentMacroName()`
remove the current macro name from stack
`void`
`popCurrentTemplateName()`
remove the current template name from stack
`void`
`pushCurrentMacroName(String s)`
set the current macro name on top of stack
`void`
`pushCurrentTemplateName(String s)`
set the current template name on top of stack
`Object`
`put(String key, Object value)`
Adds a name/value pair to the context.
`Object`
`remove(String key)`
Removes the value associated with the specified key from the context.
`void`
`setCurrentResource(Resource r)`
`void`
`setMacroLibraries(List<Template> macroLibraries)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### AbstractContext

public AbstractContext()
default CTOR

### AbstractContext

public AbstractContext(Context inner)
Chaining constructor accepts a Context argument. It will relay get() operations into this Context in the even the 'local' get() returns null.

Parameters:
  `inner` - context to be chained

## Method Details

### internalGet

public abstract Object internalGet(String key)
Implement to return a value from the context storage.
The implementation of this method is required for proper operation of a Context implementation in general Velocity use.

Parameters:
  `key` - key whose associated value is to be returned
Returns:
  object stored in the context

### internalPut

public abstract Object internalPut(String key, Object value)
Implement to put a value into the context storage.
The implementation of this method is required for proper operation of a Context implementation in general Velocity use.

Parameters:
  `key` - key with which to associate the value
  `value` - value to be associated with the key
Returns:
  previously stored value if exists, or null

### internalContainsKey

public abstract boolean internalContainsKey(String key)
Implement to determine if a key is in the storage.
Currently, this method is not used internally by the Velocity engine.

Parameters:
  `key` - key to test for existence
Returns:
  true if found, false if not

### internalGetKeys

public abstract String[] internalGetKeys()
Implement to return an object array of key strings from your storage.
Currently, this method is not used internally by the Velocity engine.

Returns:
  array of keys

### internalRemove

public abstract Object internalRemove(String key)
Implement to remove an item from your storage.
Currently, this method is not used internally by the Velocity engine.

Parameters:
  `key` - key to remove
Returns:
  object removed if exists, else null

### put

public Object put(String key, Object value)
Adds a name/value pair to the context.

Specified by:
  `put` in interface `Context`
Parameters:
  `key` - The name to key the provided value with.
  `value` - The corresponding value.
Returns:
  Object that was replaced in the the Context if applicable or null if not.

### get

public Object get(String key)
Gets the value corresponding to the provided key from the context. Supports the chaining context mechanism. If the 'local' context doesn't have the value, we try to get it from the chained context.

Specified by:
  `get` in interface `Context`
Parameters:
  `key` - The name of the desired value.
Returns:
  The value corresponding to the provided key or null if the key param is null.

### containsKey

public boolean containsKey(String key)
Indicates whether the specified key is in the context. Provided for debugging purposes.

Specified by:
  `containsKey` in interface `Context`
Parameters:
  `key` - The key to look for.
Returns:
  true if the key is in the context, false if not.

### getKeys

public String[] getKeys()
Get all the keys for the values in the context

Specified by:
  `getKeys` in interface `Context`
Returns:
  Object[] of keys in the Context. Does not return keys in chained context.

### remove

public Object remove(String key)
Removes the value associated with the specified key from the context.

Specified by:
  `remove` in interface `Context`
Parameters:
  `key` - The name of the value to remove.
Returns:
  The value that the key was mapped to, or `null` if unmapped.

### getChainedContext

public Context getChainedContext()
returns innerContext if one is chained

Returns:
  Context if chained, `null` if not

### pushCurrentTemplateName

public void pushCurrentTemplateName(String s)
set the current template name on top of stack

Parameters:
  `s` - current template name

### popCurrentTemplateName

public void popCurrentTemplateName()
remove the current template name from stack

### getCurrentTemplateName

public String getCurrentTemplateName()
get the current template name

Returns:
  String current template name

### getTemplateNameStack

public String[] getTemplateNameStack()
get the current template name stack

Returns:
  String[] with the template name stack contents.

### pushCurrentMacroName

public void pushCurrentMacroName(String s)
set the current macro name on top of stack

Parameters:
  `s` - current macro name

### popCurrentMacroName

public void popCurrentMacroName()
remove the current macro name from stack

### getCurrentMacroName

public String getCurrentMacroName()
get the current macro name

Returns:
  String current macro name

### getCurrentMacroCallDepth

public int getCurrentMacroCallDepth()
get the current macro call depth

Returns:
  int current macro call depth

### getMacroNameStack

public String[] getMacroNameStack()
get the current macro name stack

Returns:
  String[] with the macro name stack contents.

### icacheGet

public IntrospectionCacheData icacheGet(Object key)
returns an IntrospectionCache Data (@see IntrospectionCacheData) object if exists for the key

Parameters:
  `key` - key to find in cache
Returns:
  cache object

### icachePut

public void icachePut(Object key, IntrospectionCacheData o)
places an IntrospectionCache Data (@see IntrospectionCacheData) element in the cache for specified key

Parameters:
  `key` - key
  `o` - IntrospectionCacheData object to place in cache

### setCurrentResource

public void setCurrentResource(Resource r)

See Also:
  - `InternalHousekeepingContext.setCurrentResource(org.apache.velocity.runtime.resource.Resource)`

### getCurrentResource

public Resource getCurrentResource()

See Also:
  - `InternalHousekeepingContext.getCurrentResource()`

### setMacroLibraries

public void setMacroLibraries(List<Template> macroLibraries)

See Also:
  - `InternalHousekeepingContext.setMacroLibraries(List)`

### getMacroLibraries

public List<Template> getMacroLibraries()

See Also:
  - `InternalHousekeepingContext.getMacroLibraries()`

### attachEventCartridge

public EventCartridge attachEventCartridge(EventCartridge ec)

Specified by:
  `attachEventCartridge` in interface `InternalEventContext`
Parameters:
  `ec` -
Returns:
  The old EventCartridge.
See Also:
  - `InternalEventContext.attachEventCartridge(org.apache.velocity.app.event.EventCartridge)`

### getEventCartridge

public EventCartridge getEventCartridge()

Specified by:
  `getEventCartridge` in interface `InternalEventContext`
Returns:
  The current EventCartridge.
See Also:
  - `InternalEventContext.getEventCartridge()`